package main

import (
	"log"
	"net/http"
	"strconv"

	"./core/database"
	"./core/errors"
	req "./core/request"
	res "./core/response"
)

func main() {
	dbConfig := database.Config{
		config.DATABASE_HOST,
		config.DATABASE_PORT,
		config.DATABASE_USER,
		config.DATABASE_PASS,
		config.DATABASE_SCHEMA,
	}

	database.Init(dbConfig)

	http.HandleFunc("/", func(w http.ResponseWriter, r *http.Request) {

		res.SetResponseWriter(w)
		req.SetRequest(r)

		if !database.IsConnected {
			errors.InternalError("Conexão com a base de dados falhou!")
			res.JSON(errors.Get())
			return
		}

		Routes.Match(w, r)
	})

	log.Fatal(http.ListenAndServe(":"+strconv.Itoa(config.SERVER_PORT), nil))
}
